const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AgencesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const agences = await db.agences.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    return agences;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const agencesData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const agences = await db.agences.bulkCreate(agencesData, { transaction });

    // For each item created, replace relation files

    return agences;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const agences = await db.agences.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    updatePayload.updatedById = currentUser.id;

    await agences.update(updatePayload, { transaction });

    return agences;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const agences = await db.agences.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of agences) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of agences) {
        await record.destroy({ transaction });
      }
    });

    return agences;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const agences = await db.agences.findByPk(id, options);

    await agences.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await agences.destroy({
      transaction,
    });

    return agences;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const agences = await db.agences.findOne({ where }, { transaction });

    if (!agences) {
      return agences;
    }

    const output = agences.get({ plain: true });

    output.users_agences = await agences.getUsers_agences({
      transaction,
    });

    output.claims_agences = await agences.getClaims_agences({
      transaction,
    });

    output.clients_agences = await agences.getClients_agences({
      transaction,
    });

    output.company_profiles_agences = await agences.getCompany_profiles_agences(
      {
        transaction,
      },
    );

    output.drivers_agences = await agences.getDrivers_agences({
      transaction,
    });

    output.expenses_agences = await agences.getExpenses_agences({
      transaction,
    });

    output.guarantees_agences = await agences.getGuarantees_agences({
      transaction,
    });

    output.infractions_agences = await agences.getInfractions_agences({
      transaction,
    });

    output.invoices_saas_agences = await agences.getInvoices_saas_agences({
      transaction,
    });

    output.maintenance_agences = await agences.getMaintenance_agences({
      transaction,
    });

    output.payments_agences = await agences.getPayments_agences({
      transaction,
    });

    output.plans_agences = await agences.getPlans_agences({
      transaction,
    });

    output.reservations_agences = await agences.getReservations_agences({
      transaction,
    });

    output.subscriptions_agences = await agences.getSubscriptions_agences({
      transaction,
    });

    output.tenants_agences = await agences.getTenants_agences({
      transaction,
    });

    output.vehicle_conditions_agences =
      await agences.getVehicle_conditions_agences({
        transaction,
      });

    output.vehicles_agences = await agences.getVehicles_agences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('agences', 'name', filter.name),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.agences.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('agences', 'name', query),
        ],
      };
    }

    const records = await db.agences.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
